VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "FTP Demo"
   ClientHeight    =   2070
   ClientLeft      =   150
   ClientTop       =   540
   ClientWidth     =   7395
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   138
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   493
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdStop 
      Caption         =   "Exit"
      Height          =   375
      Left            =   4920
      TabIndex        =   2
      Top             =   1320
      Width           =   1335
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Sync"
      Height          =   375
      Left            =   840
      TabIndex        =   0
      Top             =   1320
      Width           =   1335
   End
   Begin VB.Label lblTitle 
      Alignment       =   2  'Center
      Caption         =   "Sync files on the local PC with the remote FTP server"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   7215
   End
   Begin VB.Label lblStatus 
      Alignment       =   2  'Center
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   7215
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub cmdStart_Click()
    Dim lResult As Long
    Dim lTimeout As Long
    Dim sFile As FTPFile
    Dim sFilename As String
    Dim lFilesize As Long
    Dim dCreatedDate As String
    Dim dAccessedDate As String
    Dim dWrittenDate As String
    Dim sAttributes As String
    Dim sFTPSession As String
    Dim sFTPUsername As String
    Dim sFTPPassword As String
    Dim lPassive As Long

    Dim lStart, lEnd As Long
    Dim bySegment As Byte
    Dim lError As Long

    lblStatus.Caption = "FTP Start"
    lblStatus.Refresh
    
' Set-up defaults to Sapphire's test FTP server.
    sLocalPath = "C:\"
    sFTPSession = "ftp.sapphire-solutions.co.uk"
    sFTPUsername = "ftp.sapphireftp"
    sFTPPassword = "sapphire123"

    lblStatus.Caption = "FTP Connecting"
    lblStatus.Refresh

    lPassive = 1
    lTimeout = 10000 'Timeout in milliseconds
    
' Open FTP connection
    lResult = sFTPOpen(sFTPSession, DEFAULT_FTP_PORT, sFTPUsername, sFTPPassword, lPassive, lTimeout, SapphireFTPLicence)
    If lResult <> FTP_NO_ERROR Then
        MsgBox "Unable to connect to server" & vbNewLine & vbNewLine & "Error: " & FTPErrorText(lResult), vbOKOnly + vbExclamation, "Sapphire FTP"
        bFTPConnected = False
        lblStatus.Caption = "FTP Disconnected"
        lblStatus.Refresh
    Else
        bFTPConnected = True
        lblStatus.Caption = "FTP Connected"
        lblStatus.Refresh
    End If

    If bFTPConnected Then
' Copy all file from the remote FTP server directory "Download" to the local PC directory "Download"
        sLocalPath = "C:\DownLoad\"
        lError = sFTPChangeDirectory("DownLoad", SapphireFTPLicence)

        sFile = FTPFindFirstFile("*.*")
        While sFile.Filename <> ""
            ' Make sure this file is not a directory
            If sFile.Size > 0 And sFile.IsDirectory = False Then
                lblStatus.Caption = "Downloading " & sFile.Filename
                lblStatus.Refresh
                lResult = FTPDownloadFile(sFile.Filename, sLocalPath & sFile.Filename, False, FTP_TRANSFER_BINARY)
                If lResult <> FTP_NO_ERROR Then
                    MsgBox "Unable to download file" & vbNewLine & vbNewLine & "Error: " & FTPErrorText(lResult), vbOKOnly + vbExclamation, "Sapphire FTP"
                End If
            End If
            sFile = FTPFindNextFile()
        Wend

' Copy all file from the local PC directory "Upload" to the remote FTP server directory "Upload"
        sLocalPath = "C:\UpLoad\"
        lError = sFTPChangeDirectory("..", SapphireFTPLicence)
        lError = sFTPChangeDirectory("UpLoad", SapphireFTPLicence)

        sFilename = Dir(sLocalPath & "*.*")
        While sFilename <> ""
            lblStatus.Caption = "Uploading " & sFilename
            lblStatus.Refresh
            lResult = FTPUploadFile(sLocalPath & sFilename, sFilename, FTP_TRANSFER_BINARY)
            If lResult <> FTP_NO_ERROR Then
                MsgBox "Unable to upload file" & vbNewLine & vbNewLine & "Error: " & FTPErrorText(lResult), vbOKOnly + vbExclamation, "Sapphire FTP"
            End If
            sFilename = Dir
        Wend

' Close FTP connection
        lblStatus.Caption = "FTP Disconnecting"
        lblStatus.Refresh
        lResult = sFTPClose(SapphireFTPLicence)
        If lResult <> FTP_NO_ERROR Then
            MsgBox "Unable to close connection" & vbNewLine & vbNewLine & "Error: " & FTPErrorText(lResult), vbOKOnly + vbExclamation, "Sapphire FTP"
        Else
            lblStatus.Caption = "FTP Disconnected"
            lblStatus.Refresh
        End If
    End If
End Sub

Private Sub cmdStop_Click()
    Unload Me
End Sub
