using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace FTPDemo
{
	/// <summary>
	/// Summary description for frmFTPExplorer.
	/// </summary>
	public class frmFTPExplorer : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.MenuItem menuRefresh;
		internal System.Windows.Forms.MenuItem menuRename;
		internal System.Windows.Forms.MenuItem MenuItem11;
		internal System.Windows.Forms.MenuItem menuZoom;
		internal System.Windows.Forms.Panel pnlMain;
		internal System.Windows.Forms.Button cmdRemote;
		internal System.Windows.Forms.Button cmdOpenDIR;
		internal System.Windows.Forms.Button cmdLocal;
		internal System.Windows.Forms.ListView lstLocal;
		internal System.Windows.Forms.Button cmdDisconnect;
		internal System.Windows.Forms.Button cmdConnect;
		internal System.Windows.Forms.Label lblLocal;
		internal System.Windows.Forms.Label lblStatus;
		internal System.Windows.Forms.Button cmdBack;
		internal System.Windows.Forms.ListView lstRemote;
		internal System.Windows.Forms.Label lblRemote;
		internal System.Windows.Forms.Label lblProgress;
		internal System.Windows.Forms.MainMenu mnuFTP;
		internal System.Windows.Forms.MenuItem menuFunctions;
		internal System.Windows.Forms.MenuItem menuUpload;
		internal System.Windows.Forms.MenuItem menuDownload;
		internal System.Windows.Forms.MenuItem menuMake;
		internal System.Windows.Forms.MenuItem menuOpen;
		internal System.Windows.Forms.MenuItem menuDelete;
		internal System.Windows.Forms.MenuItem menuView;
	
		public frmFTPExplorer()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.menuRefresh = new System.Windows.Forms.MenuItem();
			this.menuRename = new System.Windows.Forms.MenuItem();
			this.MenuItem11 = new System.Windows.Forms.MenuItem();
			this.menuZoom = new System.Windows.Forms.MenuItem();
			this.pnlMain = new System.Windows.Forms.Panel();
			this.cmdRemote = new System.Windows.Forms.Button();
			this.cmdOpenDIR = new System.Windows.Forms.Button();
			this.cmdLocal = new System.Windows.Forms.Button();
			this.lstLocal = new System.Windows.Forms.ListView();
			this.cmdDisconnect = new System.Windows.Forms.Button();
			this.cmdConnect = new System.Windows.Forms.Button();
			this.lblLocal = new System.Windows.Forms.Label();
			this.lblStatus = new System.Windows.Forms.Label();
			this.cmdBack = new System.Windows.Forms.Button();
			this.lstRemote = new System.Windows.Forms.ListView();
			this.lblRemote = new System.Windows.Forms.Label();
			this.lblProgress = new System.Windows.Forms.Label();
			this.mnuFTP = new System.Windows.Forms.MainMenu();
			this.menuFunctions = new System.Windows.Forms.MenuItem();
			this.menuUpload = new System.Windows.Forms.MenuItem();
			this.menuDownload = new System.Windows.Forms.MenuItem();
			this.menuMake = new System.Windows.Forms.MenuItem();
			this.menuOpen = new System.Windows.Forms.MenuItem();
			this.menuDelete = new System.Windows.Forms.MenuItem();
			this.menuView = new System.Windows.Forms.MenuItem();
			// 
			// menuRefresh
			// 
			this.menuRefresh.Text = "Refresh";
			this.menuRefresh.Click += new System.EventHandler(this.menuRefresh_Click);
			// 
			// menuRename
			// 
			this.menuRename.Text = "Rename";
			this.menuRename.Click += new System.EventHandler(this.menuRename_Click);
			// 
			// MenuItem11
			// 
			this.MenuItem11.Enabled = false;
			this.MenuItem11.Text = "|";
			// 
			// menuZoom
			// 
			this.menuZoom.Text = "Zoom";
			this.menuZoom.Click += new System.EventHandler(this.menuZoom_Click);
			// 
			// pnlMain
			// 
			this.pnlMain.Controls.Add(this.cmdRemote);
			this.pnlMain.Controls.Add(this.cmdOpenDIR);
			this.pnlMain.Controls.Add(this.cmdLocal);
			this.pnlMain.Controls.Add(this.lstLocal);
			this.pnlMain.Controls.Add(this.cmdDisconnect);
			this.pnlMain.Controls.Add(this.cmdConnect);
			this.pnlMain.Controls.Add(this.lblLocal);
			this.pnlMain.Controls.Add(this.lblStatus);
			this.pnlMain.Controls.Add(this.cmdBack);
			this.pnlMain.Controls.Add(this.lstRemote);
			this.pnlMain.Controls.Add(this.lblRemote);
			this.pnlMain.Controls.Add(this.lblProgress);
			this.pnlMain.Size = new System.Drawing.Size(240, 264);
			// 
			// cmdRemote
			// 
			this.cmdRemote.Location = new System.Drawing.Point(200, 124);
			this.cmdRemote.Size = new System.Drawing.Size(32, 20);
			this.cmdRemote.Text = "Flt";
			this.cmdRemote.Click += new System.EventHandler(this.cmdRemote_Click);
			// 
			// cmdOpenDIR
			// 
			this.cmdOpenDIR.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular);
			this.cmdOpenDIR.Location = new System.Drawing.Point(8, 240);
			this.cmdOpenDIR.Size = new System.Drawing.Size(56, 20);
			this.cmdOpenDIR.Text = "Open Dir";
			this.cmdOpenDIR.Click += new System.EventHandler(this.cmdOpenDIR_Click);
			// 
			// cmdLocal
			// 
			this.cmdLocal.Location = new System.Drawing.Point(200, 20);
			this.cmdLocal.Size = new System.Drawing.Size(32, 20);
			this.cmdLocal.Text = "Flt";
			this.cmdLocal.Click += new System.EventHandler(this.cmdLocal_Click);
			// 
			// lstLocal
			// 
			this.lstLocal.Location = new System.Drawing.Point(8, 40);
			this.lstLocal.Size = new System.Drawing.Size(224, 72);
			this.lstLocal.View = System.Windows.Forms.View.Details;
			this.lstLocal.GotFocus += new System.EventHandler(this.lstLocal_GotFocus);
			// 
			// cmdDisconnect
			// 
			this.cmdDisconnect.Location = new System.Drawing.Point(80, 0);
			this.cmdDisconnect.Text = "Disconnect";
			this.cmdDisconnect.Click += new System.EventHandler(this.cmdDisconnect_Click);
			// 
			// cmdConnect
			// 
			this.cmdConnect.Location = new System.Drawing.Point(8, 0);
			this.cmdConnect.Text = "Connect";
			this.cmdConnect.Click += new System.EventHandler(this.cmdConnect_Click);
			// 
			// lblLocal
			// 
			this.lblLocal.Location = new System.Drawing.Point(8, 24);
			this.lblLocal.Size = new System.Drawing.Size(184, 20);
			this.lblLocal.Text = "Local Directory:";
			// 
			// lblStatus
			// 
			this.lblStatus.Location = new System.Drawing.Point(152, 0);
			this.lblStatus.Size = new System.Drawing.Size(80, 20);
			this.lblStatus.Text = "Disconnected";
			// 
			// cmdBack
			// 
			this.cmdBack.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular);
			this.cmdBack.Location = new System.Drawing.Point(176, 240);
			this.cmdBack.Size = new System.Drawing.Size(56, 20);
			this.cmdBack.Text = "Back";
			this.cmdBack.Click += new System.EventHandler(this.cmdBack_Click);
			// 
			// lstRemote
			// 
			this.lstRemote.Location = new System.Drawing.Point(8, 144);
			this.lstRemote.Size = new System.Drawing.Size(224, 88);
			this.lstRemote.View = System.Windows.Forms.View.Details;
			this.lstRemote.GotFocus += new System.EventHandler(this.lstRemote_GotFocus);
			// 
			// lblRemote
			// 
			this.lblRemote.Location = new System.Drawing.Point(8, 128);
			this.lblRemote.Size = new System.Drawing.Size(184, 20);
			this.lblRemote.Text = "Remote Directory:";
			// 
			// lblProgress
			// 
			this.lblProgress.Location = new System.Drawing.Point(8, 0);
			this.lblProgress.Size = new System.Drawing.Size(224, 16);
			this.lblProgress.Text = "Progress Label";
			// 
			// mnuFTP
			// 
			this.mnuFTP.MenuItems.Add(this.menuFunctions);
			this.mnuFTP.MenuItems.Add(this.MenuItem11);
			this.mnuFTP.MenuItems.Add(this.menuView);
			// 
			// menuFunctions
			// 
			this.menuFunctions.MenuItems.Add(this.menuUpload);
			this.menuFunctions.MenuItems.Add(this.menuDownload);
			this.menuFunctions.MenuItems.Add(this.menuMake);
			this.menuFunctions.MenuItems.Add(this.menuOpen);
			this.menuFunctions.MenuItems.Add(this.menuDelete);
			this.menuFunctions.MenuItems.Add(this.menuRename);
			this.menuFunctions.Text = "Functions";
			// 
			// menuUpload
			// 
			this.menuUpload.Text = "Upload";
			this.menuUpload.Click += new System.EventHandler(this.menuUpload_Click);
			// 
			// menuDownload
			// 
			this.menuDownload.Text = "Download";
			this.menuDownload.Click += new System.EventHandler(this.menuDownload_Click);
			// 
			// menuMake
			// 
			this.menuMake.Text = "Make Directory";
			this.menuMake.Click += new System.EventHandler(this.menuMake_Click);
			// 
			// menuOpen
			// 
			this.menuOpen.Text = "Open Directory";
			this.menuOpen.Click += new System.EventHandler(this.menuOpen_Click);
			// 
			// menuDelete
			// 
			this.menuDelete.Text = "Delete";
			this.menuDelete.Click += new System.EventHandler(this.menuDelete_Click);
			// 
			// menuView
			// 
			this.menuView.MenuItems.Add(this.menuRefresh);
			this.menuView.MenuItems.Add(this.menuZoom);
			this.menuView.Text = "View";
			// 
			// frmFTPExplorer
			// 
			this.BackColor = System.Drawing.Color.Aqua;
			this.ClientSize = new System.Drawing.Size(240, 269);
			this.Controls.Add(this.pnlMain);
			this.Menu = this.mnuFTP;
			this.Text = "FTP Explorer";
			this.Load += new System.EventHandler(this.frmFTPExplorer_Load);

		}
		#endregion

		private void cmdBack_Click(object sender, System.EventArgs e)
		{
			int iResult;

			if (clsMain.bFTPConnected == true)
			{
				if (MessageBox.Show("You are currently connected, do you wish to disconnect?", "FTPDemo", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) == DialogResult.Yes)
				{
					iResult = clsFTP.sFTPClose(clsMain.SapphireFTPLicence);
					if (iResult != clsFTP.FTP_NO_ERROR)
					{
						MessageBox.Show("Unable to close connection, Error: " + clsFTP.GetFTPError(iResult));
					}
					else
					{
						clsMain.bFTPConnected = false;
						lblStatus.Text = "Disconnected";
						lstRemote.Items.Clear();
						lblRemote.Text = "Remote Directory:";
						clsMain.fFTPMenu.Show();
						this.Hide();
					}
				}
			}
			else
			{
				clsMain.fFTPMenu.Show();
				this.Hide();
			}
		}

		private void cmdOpenDIR_Click(object sender, System.EventArgs e)
		{
	        OpenDirectory();
		}

		private void OpenDirectory()
		{
			int iResult;

			if (clsMain.bLocalFocus)
			{
				if (IsLocalSelected() == false)
				{
					MessageBox.Show("Please select a directory then select Open Dir");
				}
				else
				{
					if (lstLocal.Items[lstLocal.SelectedIndices[0]].SubItems[3].Text.IndexOf("DIR",0) >= 0)
					{
						if (clsFTP.sLocalChangeDirectory(lstLocal.Items[lstLocal.SelectedIndices[0]].Text.Substring(1, lstLocal.Items[lstLocal.SelectedIndices[0]].Text.Length - 2)) != 0)
							MessageBox.Show("Unable to change directory");
						else
							clsFTP.sLocalRefreshList();
					}
					else
					{
						MessageBox.Show("Please select a directory then select Open Dir");
					}
				}
			}
			else
			{
				if (IsRemoteSelected() == false)
				{
					MessageBox.Show("Please select a directory then select Open Dir");
				}
				else
				{
					if (lstRemote.Items[lstRemote.SelectedIndices[0]].SubItems[3].Text.IndexOf("DIR",0) >= 0)
					{
						iResult = clsFTP.sFTPChangeDirectory(lstRemote.Items[lstRemote.SelectedIndices[0]].Text.Substring(1, lstRemote.Items[lstRemote.SelectedIndices[0]].Text.Length - 2), clsMain.SapphireFTPLicence);
						if (iResult != clsFTP.FTP_NO_ERROR)
							MessageBox.Show("Unable to change directory, Error: " + clsFTP.GetFTPError(iResult));
						else
							RefreshRemote();
					}
					else
					{
						MessageBox.Show("Please select a directory then select Open Dir");
					}
				}
			}
		}

		private bool IsLocalSelected()
		{
			try
			{
				if (lstLocal.SelectedIndices.Count > 0)
					return true;
			}
			catch
			{
				return false;
			}
			return false;
		}

		private bool IsRemoteSelected()
		{
			try
			{
				if (lstRemote.SelectedIndices.Count > 0)
					return true;
			}
			catch
			{
				return false;
			}
			return false;
		}

		private static void RefreshRemote()
		{
			string sFile;
			string sCurrentDirectory;

			sCurrentDirectory = clsFTP.FTPCurrentDirectory();
			clsMain.fFTPExplorer.lblRemote.Text = "Remote Directory: " + sCurrentDirectory + clsFTP.sRemoteFilter;

			clsMain.fFTPExplorer.lstRemote.Items.Clear();

			// Refresh connection to make sure cached items are not used
			if (clsFTP.sFTPReconnect(clsFTP.iPassive, clsMain.SapphireFTPLicence) == 0)
				MessageBox.Show("Unable to reconnect");

			sFile = clsFTP.FTPFindFirstFile(clsFTP.sRemoteFilter);
			while (sFile != "")
			{
				AddRemoteFile(sFile);
				sFile = clsFTP.FTPFindNextFile();
			}
		}

		private static void AddRemoteFile(string sFileString)
		{
			string sFilename = "";
			int iFilesize = 0;
			string dCreatedDate = "";
			string dAccessedDate = "";
			string dWrittenDate = "";
			string sAttributes = "";

			ListViewItem liFile;

			string [] sDetails = sFileString.Split('|');
			if (sDetails.GetUpperBound(0) > 0)
			{
				sFilename = sDetails[0];
				iFilesize = Convert.ToInt32(sDetails[1]);
				dCreatedDate = sDetails[2];
				dAccessedDate = sDetails[3];
				dWrittenDate = sDetails[4];
				sAttributes = sDetails[5];
			}

			if (sAttributes.IndexOf("DIR",0) >= 0)
				sFilename = "[" + sFilename + "]";

			liFile = new ListViewItem(sFilename);
			liFile.SubItems.Add(clsFTP.GetFileSizeText(iFilesize));
			liFile.SubItems.Add(dWrittenDate);
			liFile.SubItems.Add(sAttributes);
			clsMain.fFTPExplorer.lstRemote.Items.Add(liFile);
		}

		private void cmdConnect_Click(object sender, System.EventArgs e)
		{
			int iResult;
			int iTimeOut;

			if (clsMain.bFTPConnected == true)
			{
				if (MessageBox.Show("You are already connected, do you wish to reconnect?", "FTPDemo", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) == DialogResult.Yes)
				{
					iResult = clsFTP.sFTPClose(clsMain.SapphireFTPLicence);
					if (iResult != clsFTP.FTP_NO_ERROR)
					{
						MessageBox.Show("Unable to close connection, Error: " + clsFTP.GetFTPError(iResult));
						return;
					}
				}
			}

			if (MessageBox.Show("Do you wish to connect in Passive mode?", "FTPDemo", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) == DialogResult.Yes)
				clsFTP.iPassive = 1;
			else
				clsFTP.iPassive = 0;

			lblStatus.Text = "Connecting";

			iTimeOut = 10000; //Timeout in milliseconds
			iResult = clsFTP.sFTPOpen(clsFTP.sFTPSession, clsFTP.DEFAULT_FTP_PORT, clsFTP.sFTPUsername, clsFTP.sFTPPassword, clsFTP.iPassive, iTimeOut, clsMain.SapphireFTPLicence);
			if (iResult != clsFTP.FTP_NO_ERROR)
			{
				MessageBox.Show("Unable to connect to server, Error: " + clsFTP.GetFTPError(iResult));
				clsMain.bFTPConnected = false;
				lblStatus.Text = "Disconnected";
			}
			else
			{
				clsMain.bFTPConnected = true;
				lblStatus.Text = "Connected";
				RefreshRemote();
			}
		}

		private void cmdDisconnect_Click(object sender, System.EventArgs e)
		{
			int iResult;

			lblStatus.Text = "Disconnecting";
			iResult = clsFTP.sFTPClose(clsMain.SapphireFTPLicence);
			if (iResult != clsFTP.FTP_NO_ERROR)
			{
				MessageBox.Show("Unable to close connection, Error: " + clsFTP.GetFTPError(iResult));
			}
			else
			{
				lblStatus.Text = "Disconnected";
				clsMain.bFTPConnected = false;

				lstRemote.Items.Clear();
				lblRemote.Text = "Remote Directory:";
			}
		}

		private void cmdLocal_Click(object sender, System.EventArgs e)
		{
			clsFTP.sLocalFilter = Microsoft.VisualBasic.Interaction.InputBox("Enter Local Filter String:", "FTPDemo", clsFTP.sLocalFilter,10,10);
			if (clsFTP.sLocalFilter == "")
				clsFTP.sLocalFilter = "*.*";
			clsMain.bLocalFocus = true;
			RefreshDirectory();
		}

		private void cmdRemote_Click(object sender, System.EventArgs e)
		{
			clsFTP.sRemoteFilter = Microsoft.VisualBasic.Interaction.InputBox("Enter Remote Filter String:", "FTPDemo", clsFTP.sRemoteFilter,10,10);
			if (clsFTP.sRemoteFilter == "")
				clsFTP.sRemoteFilter = "*.*";
			clsMain.bLocalFocus = false;
			RefreshDirectory();
		}

		private static void RefreshDirectory()
		{
			if (clsMain.bLocalFocus == true)
			{
				clsFTP.sLocalRefreshList();
			}
			else
			{
				if (clsMain.bFTPConnected == true)
					RefreshRemote();
				else
					MessageBox.Show("You must be connected to a FTP server before you can refresh");
			}
		}

		private void frmFTPExplorer_Load(object sender, System.EventArgs e)
		{
			ColumnHeader colHeader;

			clsMain.byZoom = 1;
			clsFTP.InitialiseFileManager();

			colHeader = new ColumnHeader();
			colHeader.Text = "Name";
			colHeader.TextAlign = HorizontalAlignment.Left;
			colHeader.Width = 120;
			lstLocal.Columns.Add(colHeader);

			colHeader = new ColumnHeader();
			colHeader.Text = "Name";
			colHeader.TextAlign = HorizontalAlignment.Left;
			colHeader.Width = 120;
			lstRemote.Columns.Add(colHeader);

			colHeader = new ColumnHeader();
			colHeader.Text = "Size";
			colHeader.TextAlign = HorizontalAlignment.Right;
			colHeader.Width = 80;
			lstLocal.Columns.Add(colHeader);

			colHeader = new ColumnHeader();
			colHeader.Text = "Size";
			colHeader.TextAlign = HorizontalAlignment.Right;
			colHeader.Width = 80;
			lstRemote.Columns.Add(colHeader);

			colHeader = new ColumnHeader();
			colHeader.Text = "Date";
			colHeader.TextAlign = HorizontalAlignment.Left;
			colHeader.Width = 140;
			lstLocal.Columns.Add(colHeader);

			colHeader = new ColumnHeader();
			colHeader.Text = "Date";
			colHeader.TextAlign = HorizontalAlignment.Left;
			colHeader.Width = 140;
			lstRemote.Columns.Add(colHeader);

			colHeader = new ColumnHeader();
			colHeader.Text = "Attributes";
			colHeader.TextAlign = HorizontalAlignment.Left;
			colHeader.Width = 100;
			lstLocal.Columns.Add(colHeader);

			colHeader = new ColumnHeader();
			colHeader.Text = "Attributes";
			colHeader.TextAlign = HorizontalAlignment.Left;
			colHeader.Width = 100;
			lstRemote.Columns.Add(colHeader);

			clsFTP.sLocalFilter = "*.*";
			clsFTP.sRemoteFilter = "*.*";
			clsFTP.sLocalRefreshList();
		}

		private void lstLocal_GotFocus(object sender, System.EventArgs e)
		{
			clsMain.bLocalFocus = true;
		}

		private void lstRemote_GotFocus(object sender, System.EventArgs e)
		{
			clsMain.bLocalFocus = false;
		}

		private void menuUpload_Click(object sender, System.EventArgs e)
		{
			int iResult;
			bool bOverwrite;
			string sCurrentRemoteDir;
			int iBytes;

			if (IsLocalSelected() == false)
			{
				MessageBox.Show("Please select the local item you wish to upload");
			}
			else
			{
				if (clsMain.bFTPConnected == false)
				{
					MessageBox.Show("You must be connected to a FTP server to upload files");
				}
				else
				{
					// Make sure there are files selected
					if (lstLocal.SelectedIndices.Count > 0)
					{
						if (lstLocal.Items[lstLocal.SelectedIndices[0]].SubItems[3].Text.IndexOf("DIR",0) < 0)
						{
							// Refresh connection to make sure cached items are not used
							if (clsFTP.sFTPReconnect(clsFTP.iPassive, clsMain.SapphireFTPLicence) == 0)
							{
								MessageBox.Show("Unable to reconnect");
								bOverwrite = false;
							}
							else
							{
								sCurrentRemoteDir = clsFTP.FTPCurrentDirectory();

								if (clsFTP.sFTPFileExists(sCurrentRemoteDir + "//" + lstLocal.Items[lstLocal.SelectedIndices[0]].Text, clsMain.SapphireFTPLicence) == 1)
								{
									if (MessageBox.Show("Do you want to overwrite remote file?", "FTPDemo", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) == DialogResult.Yes)
										bOverwrite = true;
									else
										bOverwrite = false;
								}
								else
								{
									bOverwrite = true;
								}
							}

							if (bOverwrite == true)
							{
								iBytes = 0;
								iResult = clsFTP.sFTPPushStart(clsFTP.sLocalCurrentDirectory() + lstLocal.Items[lstLocal.SelectedIndices[0]].Text, lstLocal.Items[lstLocal.SelectedIndices[0]].Text, clsFTP.FTP_TRANSFER_BINARY, clsMain.SapphireFTPLicence);
								if (iResult != clsFTP.FTP_NO_ERROR)
								{
									MessageBox.Show("Unable to upload file, Error: " + clsFTP.GetFTPError(iResult));
								}
								else
								{
									lblProgress.BringToFront();
									lblProgress.Visible = true;
									do
									{
										iResult = clsFTP.sFTPPushMore();
										iBytes = iBytes + 1;
										if (iBytes % 10 == 0)
										{
											lblProgress.Text = "Uploaded " + iBytes + "K of " + lstLocal.Items[lstLocal.SelectedIndices[0]].Text;
											lblProgress.Update();
										}
									}
									while (iResult == 0);
									lblProgress.Visible = false;
									if (iResult != 100)
										MessageBox.Show("File upload not completed, Error: " + clsFTP.GetFTPError(iResult));

									iResult = clsFTP.sFTPPushEnd();
									if (iResult != clsFTP.FTP_NO_ERROR)
										MessageBox.Show("Unable to close files, Error: " + clsFTP.GetFTPError(iResult));
									RefreshRemote();
								}
							}
						}
						else
						{
							if (MessageBox.Show("Are you sure you wish to upload local directory:" + lstLocal.Items[lstLocal.SelectedIndices[0]].Text.Substring(1, lstLocal.Items[lstLocal.SelectedIndices[0]].Text.Length - 2), "FTPDemo", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) == DialogResult.Yes)
							{
								iResult = clsFTP.sFTPUploadDirectory(clsFTP.sLocalCurrentDirectory() + lstLocal.Items[lstLocal.SelectedIndices[0]].Text.Substring(1, lstLocal.Items[lstLocal.SelectedIndices[0]].Text.Length - 2), clsMain.SapphireFTPLicence);
								if (iResult != clsFTP.FTP_NO_ERROR)
									MessageBox.Show("Unable to upload directory, Error: " + clsFTP.GetFTPError(iResult));
								else
									RefreshRemote();
							}
						}
					}
				}
			}
		}

		private void menuDownload_Click(object sender, System.EventArgs e)
		{
			int iResult;
			bool bOverwrite;
			int iBytes;

			if (IsRemoteSelected() == false)
			{
				MessageBox.Show("Please select the remote item you wish to download");
			}
			else
			{
				if (clsMain.bFTPConnected == false)
				{
					MessageBox.Show("You must be connected to a FTP server to upload files");
				}
				else
				{
					// Make sure there are files selected
					if (lstRemote.Items[lstRemote.SelectedIndices[0]].SubItems[3].Text.IndexOf("DIR",0) < 0)
					{
						if (clsFTP.sLocalFileExists(clsFTP.sLocalCurrentDirectory() + lstRemote.Items[lstRemote.SelectedIndices[0]].Text) == true)
						{
							if (MessageBox.Show("Do you want to overwrite local file?", "FTPDemo", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) == DialogResult.Yes)
								bOverwrite = true;
							else
								bOverwrite = false;
						}
						else
						{
							bOverwrite = true;
						}

						if (bOverwrite == true)
						{
							// Refresh connection to make sure cached items are not used
							if (clsFTP.sFTPReconnect(clsFTP.iPassive, clsMain.SapphireFTPLicence) == 0)
								MessageBox.Show("Unable to reconnect");
							iBytes = 0;
							iResult = clsFTP.sFTPPullStart(lstRemote.Items[lstRemote.SelectedIndices[0]].Text, clsFTP.sLocalCurrentDirectory() + lstRemote.Items[lstRemote.SelectedIndices[0]].Text, clsFTP.FTP_OVERWRITE, clsFTP.FTP_TRANSFER_BINARY, clsMain.SapphireFTPLicence);
							if (iResult != clsFTP.FTP_NO_ERROR)
							{
								MessageBox.Show("Unable to download file, Error: " + clsFTP.GetFTPError(iResult));
							}
							else
							{
								lblProgress.BringToFront();
								lblProgress.Visible = true;
								do
								{
									iResult = clsFTP.sFTPPullMore();
									iBytes++;
									if (iBytes % 10 == 0)
									{
										lblProgress.Text = "Downloaded " + iBytes + "K of " + lstRemote.Items[lstRemote.SelectedIndices[0]].Text;
										lblProgress.Update();
									}
								}
								while (iResult == 0);
								lblProgress.Visible = false;
								if (iResult != 100)
									MessageBox.Show("File download not completed, Error: " + clsFTP.GetFTPError(iResult));

								iResult = clsFTP.sFTPPullEnd();
								if (iResult != clsFTP.FTP_NO_ERROR)
									MessageBox.Show("Unable to close files, Error: " + clsFTP.GetFTPError(iResult));
								clsFTP.sLocalRefreshList();
							}
						}
					}
					else
					{
						if (MessageBox.Show("Are you sure you wish to download remote directory:" + lstRemote.Items[lstRemote.SelectedIndices[0]].Text.Substring(1, lstRemote.Items[lstRemote.SelectedIndices[0]].Text.Length - 2), "FTPDemo", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) == DialogResult.Yes)
						{
							// Refresh connection to make sure cached items are not used
							if (clsFTP.sFTPReconnect(clsFTP.iPassive, clsMain.SapphireFTPLicence) == 0)
								MessageBox.Show("Unable to reconnect");
							iResult = clsFTP.sFTPDownloadDirectory(lstRemote.Items[lstRemote.SelectedIndices[0]].Text.Substring(1, lstRemote.Items[lstRemote.SelectedIndices[0]].Text.Length - 2), clsFTP.sLocalCurrentDirectory().Substring(0, clsFTP.sLocalCurrentDirectory().Length - 1), clsMain.SapphireFTPLicence);
							if (iResult != clsFTP.FTP_NO_ERROR)
								MessageBox.Show("Unable to download directory, Error: " + clsFTP.GetFTPError(iResult));
							else
								clsFTP.sLocalRefreshList();
						}
					}
				}
			}
		}

		private void menuMake_Click(object sender, System.EventArgs e)
		{
			string sDirectory = "";
			int iResult;

			sDirectory = Microsoft.VisualBasic.Interaction.InputBox("Enter the name of the new directory", "FTPDemo", sDirectory,10,10);

			if (sDirectory != "")
			{
				if (clsMain.bLocalFocus == true)
				{
					if (clsFTP.sLocalMakeDirectory(sDirectory) != 0)
						MessageBox.Show("Unable to create directory on local device");
					else
						clsFTP.sLocalRefreshList();
				}            
				else
				{
					if (clsMain.bFTPConnected == true)
					{
						iResult = clsFTP.sFTPMakeDirectory(sDirectory, clsMain.SapphireFTPLicence);
						if (iResult != clsFTP.FTP_NO_ERROR)
							MessageBox.Show("Unable to create directory on remote server, Error: " + clsFTP.GetFTPError(iResult));
						else
							RefreshRemote();
					}
					else
					{
						MessageBox.Show("You have to be connected to make a directory");
					}
				}
			}
		}

		private void menuOpen_Click(object sender, System.EventArgs e)
		{
			OpenDirectory();
		}

		private void menuDelete_Click(object sender, System.EventArgs e)
		{
			int iResult;

			if (clsMain.bLocalFocus == true)
			{
				if (IsLocalSelected() == false)
				{
					MessageBox.Show("Please select the item you wish to delete");
				}
				else
				{
					if (lstLocal.Items[lstLocal.SelectedIndices[0]].SubItems[3].Text.IndexOf("DIR",0) >= 0)
					{
						// Remove the directory
						if (MessageBox.Show("Are you sure you wish to remove directory:" + lstLocal.Items[lstLocal.SelectedIndices[0]].Text.Substring(1, lstLocal.Items[lstLocal.SelectedIndices[0]].Text.Length - 2), "FTPDemo", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) == DialogResult.Yes)
						{
							if (clsFTP.sLocalRemoveDirectory(lstLocal.Items[lstLocal.SelectedIndices[0]].Text.Substring(1, lstLocal.Items[lstLocal.SelectedIndices[0]].Text.Length - 2)) != 0)
								MessageBox.Show("Unable to remove directory");
							else
								clsFTP.sLocalRefreshList();
						}
					}
					else
					{
						// Remove the file
						if (MessageBox.Show("Are you sure you wish to remove file:" + lstLocal.Items[lstLocal.SelectedIndices[0]].Text, "FTPDemo", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) == DialogResult.Yes)
						{
							if (clsFTP.sLocalRemoveFile(lstLocal.Items[lstLocal.SelectedIndices[0]].Text) != 0)
								MessageBox.Show("Unable to remove file");
							else
								clsFTP.sLocalRefreshList();
						}
					}
				}
			}
			else
			{
				// Make sure an item is selected
				if (IsRemoteSelected() == false)
				{
					MessageBox.Show("Please select the item you wish to delete");
				}
				else
				{
					if (lstRemote.Items[lstRemote.SelectedIndices[0]].SubItems[3].Text.IndexOf("DIR",0) >= 0)
					{
						// Remove the directory
						if (MessageBox.Show("Are you sure you wish to remove directory:" + lstRemote.Items[lstRemote.SelectedIndices[0]].Text.Substring(1, lstRemote.Items[lstRemote.SelectedIndices[0]].Text.Length - 2), "FTPDemo", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) == DialogResult.Yes)
						{
							// Refresh connection to make sure cached items are not used
							if (clsFTP.sFTPReconnect(clsFTP.iPassive, clsMain.SapphireFTPLicence) == 0)
								MessageBox.Show("Unable to reconnect");
							iResult = clsFTP.sFTPRemoveDirectory(lstRemote.Items[lstRemote.SelectedIndices[0]].Text.Substring(1, lstRemote.Items[lstRemote.SelectedIndices[0]].Text.Length - 2), clsMain.SapphireFTPLicence);
							if (iResult != clsFTP.FTP_NO_ERROR)
								MessageBox.Show("Unable to remove directory, Error: " + clsFTP.GetFTPError(iResult));
							else
								RefreshRemote();
						}
					}
					else
					{
						// Remove the file
						if (MessageBox.Show("Are you sure you wish to remove file:" + lstRemote.Items[lstRemote.SelectedIndices[0]].Text, "FTPDemo", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) == DialogResult.Yes)
						{
							iResult = clsFTP.sFTPRemoveFile(lstRemote.Items[lstRemote.SelectedIndices[0]].Text, clsMain.SapphireFTPLicence);
							if (iResult != clsFTP.FTP_NO_ERROR)
								MessageBox.Show("Unable to remove file, Error: " + clsFTP.GetFTPError(iResult));
							else
								RefreshRemote();
						}
					}
				}
			}
		}

		private void menuRename_Click(object sender, System.EventArgs e)
		{
			int iResult;

			if (clsMain.bLocalFocus == true)
			{
				if (IsLocalSelected() == false)
				{
					MessageBox.Show("Please select an item to rename");
				}
				else
				{
					// See if it is a directory to rename
					if (lstLocal.Items[lstLocal.SelectedIndices[0]].SubItems[3].Text.IndexOf("DIR",0) >= 0)
					{
						// Rename directory
						clsMain.sBeforeRename = lstLocal.Items[lstLocal.SelectedIndices[0]].Text.Substring(1, lstLocal.Items[lstLocal.SelectedIndices[0]].Text.Length - 2);
						clsMain.sAfterRename = Microsoft.VisualBasic.Interaction.InputBox("Enter new local directory name:", "FTPDemo", clsMain.sBeforeRename,10,10);
					}
					else
					{
						// Rename file
						clsMain.sBeforeRename = lstLocal.Items[lstLocal.SelectedIndices[0]].Text;
						clsMain.sAfterRename = Microsoft.VisualBasic.Interaction.InputBox("Enter new local file name:", "FTPDemo", clsMain.sBeforeRename,10,10);
					}

					if (clsFTP.sLocalRenameFile(clsMain.sBeforeRename, clsMain.sAfterRename) != 0)
					{
						MessageBox.Show("Unable to rename local file");
					}
					else
					{
						// See if it is a directory to rename
						if (lstLocal.Items[lstLocal.SelectedIndices[0]].SubItems[3].Text.IndexOf("DIR",0) >= 0)
							lstLocal.Items[lstLocal.SelectedIndices[0]].Text = "[" + clsMain.sAfterRename + "]";
						else
							lstLocal.Items[lstLocal.SelectedIndices[0]].Text = clsMain.sAfterRename;
					}
				}
			}
			else
			{
				if (IsRemoteSelected() == false)
				{
					MessageBox.Show("Please select an item to rename");
				}
				else
				{
					// See if it is a directory to rename
					if (lstRemote.Items[lstRemote.SelectedIndices[0]].SubItems[3].Text.IndexOf("DIR",0) >= 0)
					{
						// Rename directory
						clsMain.sBeforeRename = lstRemote.Items[lstRemote.SelectedIndices[0]].Text.Substring(1, lstRemote.Items[lstRemote.SelectedIndices[0]].Text.Length - 2);
						clsMain.sAfterRename = Microsoft.VisualBasic.Interaction.InputBox("Enter new remote directory name:", "FTPDemo", clsMain.sBeforeRename,10,10);
					}
					else
					{
						// Rename file
						clsMain.sBeforeRename = lstRemote.Items[lstRemote.SelectedIndices[0]].Text;
						clsMain.sAfterRename = Microsoft.VisualBasic.Interaction.InputBox("Enter new remote file name:", "FTPDemo", clsMain.sBeforeRename,10,10);
					}

					iResult = clsFTP.sFTPRenameFile(clsMain.sBeforeRename, clsMain.sAfterRename, clsMain.SapphireFTPLicence);
					if (iResult != clsFTP.FTP_NO_ERROR)
					{
						MessageBox.Show("Unable to rename remote file, Error: " + clsFTP.GetFTPError(iResult));
					}
					else
					{
						// See if it is a directory to rename
						if (lstRemote.Items[lstRemote.SelectedIndices[0]].SubItems[3].Text.IndexOf("DIR",0) >= 0)
							lstRemote.Items[lstRemote.SelectedIndices[0]].Text = "[" + clsMain.sAfterRename + "]";
						else
							lstRemote.Items[lstRemote.SelectedIndices[0]].Text = clsMain.sAfterRename;
					}
				}
			}
		}

		private void menuRefresh_Click(object sender, System.EventArgs e)
		{
			RefreshDirectory();
		}

		private void menuZoom_Click(object sender, System.EventArgs e)
		{
			clsMain.byZoom++;
			if (clsMain.byZoom == 4)
				clsMain.byZoom = 1;
			DisplayZoom();
		}

		private void DisplayZoom()
		{
			switch(clsMain.byZoom)       
			{         
				case 1:   
					// Display both windows
					lblLocal.Visible = true;
					lstLocal.Visible = true;
					cmdLocal.Visible = true;
					lstLocal.Height = 80;

					lblRemote.Visible = true;
					lblRemote.Top = 128;
					lstRemote.Visible = true;
					lstRemote.Top = 144;
					lstRemote.Height = 88;
					cmdRemote.Top = 124;
					cmdRemote.Visible = true;
					break;                  
				case 2:            
					// Display the local window only
					lblRemote.Visible = false;
					lstRemote.Visible = false;
					lblLocal.Visible = true;
					lstLocal.Visible = true;
					cmdLocal.Visible = true;
					cmdRemote.Visible = false;
					lstLocal.Height = 192;
					break;           
				case 3:            
					// Display the remote window only
					lblRemote.Visible = true;
					lstRemote.Visible = true;
					lblLocal.Visible = false;
					lstLocal.Visible = false;
					cmdLocal.Visible = false;
					cmdRemote.Visible = true;
					lblRemote.Top = 24;
					lstRemote.Top = 40;
					lstRemote.Height = 192;
					cmdRemote.Top = 20;
					break;
				default:            
					break;      
			}
		}
	}
}
